VERSION 5.00
Begin VB.UserControl optBlack 
   BackColor       =   &H00000000&
   ClientHeight    =   405
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1695
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   15.75
      Charset         =   162
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   PropertyPages   =   "optBlack.ctx":0000
   ScaleHeight     =   405
   ScaleWidth      =   1695
   ToolboxBitmap   =   "optBlack.ctx":002E
   Begin BLACKControls.btnBlack btnCaption 
      Height          =   405
      Left            =   405
      TabIndex        =   0
      Top             =   15
      Width           =   120
      _ExtentX        =   212
      _ExtentY        =   714
      Autosize        =   -1  'True
   End
   Begin VB.Image imgTrue 
      Height          =   240
      Left            =   60
      Picture         =   "optBlack.ctx":0340
      Top             =   60
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image imgFalse 
      Height          =   240
      Left            =   60
      Picture         =   "optBlack.ctx":0682
      Top             =   60
      Width           =   240
   End
End
Attribute VB_Name = "optBlack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Default Property Values:
Const m_def_TCI = True
Const m_def_TCT = True

'Property Variables:
Dim m_Enabled As Boolean
Dim m_TCI As Boolean
Dim m_TCT As Boolean
Dim prpRA As Boolean
Dim prpII As Integer
Dim CH As Boolean

'Event Declarations:
Event Change()
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
Event Click()
Event DblClick()
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp

Private Sub btnCaption_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyDown Or KeyCode = vbKeyRight Then
    If UserControl.Extender.Index <> "" Then
        For Each optBlack In UserControl.Extender.Container
            If optBlack.Name = UserControl.Extender.Name Then
                If optBlack.Index = UserControl.Extender.Index + 1 Then
                    optBlack.SetFocus
                    optBlack.Value = True
                End If
            End If
        Next
    End If
ElseIf KeyCode = vbKeyUp Or KeyCode = vbKeyLeft Then
    If UserControl.Extender.Index <> "" Then
        For Each optBlack In UserControl.Extender.Container
            If optBlack.Name = UserControl.Extender.Name Then
                If optBlack.Index = UserControl.Extender.Index - 1 Then
                    optBlack.SetFocus
                    optBlack.Value = True
                End If
            End If
        Next
    End If
End If
End Sub

Private Sub imgTrue_Click()
        If TCI Then Value = Not Value
    RaiseEvent Click
End Sub

Private Sub imgTrue_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub imgTrue_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub imgTrue_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub imgTrue_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub imgFalse_Click()
        If TCI Then Value = Not Value
    RaiseEvent Click
End Sub

Private Sub imgFalse_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub imgFalse_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub imgFalse_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub imgFalse_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub btnCaption_Click()
        If TCT Then Value = Not Value
    RaiseEvent Click
End Sub

Private Sub btnCaption_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub btnCaption_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub btnCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub btnCaption_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_TCI = m_def_TCI
    m_TCT = m_def_TCT
    prpRA = False
    prpII = 0
        ReCall
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    btnCaption.Caption = PropBag.ReadProperty("Caption", "")
    Set btnCaption.Font = PropBag.ReadProperty("Font", UserControl.Font)
    btnCaption.ForeColor = PropBag.ReadProperty("ForeColor", &HFFFFFF)
    btnCaption.FocusColor = PropBag.ReadProperty("FocusColor", &HC0FFFF)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", 0)
    btnCaption.ShadowColor = PropBag.ReadProperty("ShadowColor", &H8000000C)
    For Each Control In UserControl
        Control.Enabled = PropBag.ReadProperty("Enabled", True)
    Next
    m_TCI = PropBag.ReadProperty("TCI", m_def_TCI)
    m_TCT = PropBag.ReadProperty("TCT", m_def_TCT)
    imgTrue.Visible = PropBag.ReadProperty("Value", False)
    imgFalse.Visible = Not imgTrue.Visible
    prpRA = PropBag.ReadProperty("RightAligned", False)
    prpII = PropBag.ReadProperty("ItemIndex", 0)
    If prpRA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
        Call ReCall
End Sub

Private Sub UserControl_Resize()
    If prpRA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
End Sub

Private Sub UserControl_Show()
    ReCall
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Caption", btnCaption.Caption, "")
    Call PropBag.WriteProperty("Font", btnCaption.Font, UserControl.Font)
    Call PropBag.WriteProperty("ForeColor", btnCaption.ForeColor, &HFFFFFF)
    Call PropBag.WriteProperty("FocusColor", btnCaption.FocusColor, &HC0FFFF)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, 0)
    Call PropBag.WriteProperty("ShadowColor", btnCaption.ShadowColor, &H8000000C)
    Call PropBag.WriteProperty("Enabled", imgTrue.Enabled, True)
    Call PropBag.WriteProperty("TCI", m_TCI, m_def_TCI)
    Call PropBag.WriteProperty("TCT", m_TCT, m_def_TCT)
    Call PropBag.WriteProperty("Value", imgTrue.Visible, False)
    Call PropBag.WriteProperty("RightAligned", prpRA, False)
    Call PropBag.WriteProperty("ItemIndex", prpII, 0)
        ReCall
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=btnCaption,btnCaption,-1,Caption
Public Property Get Caption() As String
    Caption = btnCaption.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    btnCaption.Caption() = New_Caption
    PropertyChanged "Caption"
    If prpRA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=btnCaption,btnCaption,-1,Font
Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = btnCaption.Font
End Property

Public Property Set Font(ByVal New_Font As StdFont)
    Set btnCaption.Font = New_Font
    If prpRA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=btnCaption,btnCaption,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = btnCaption.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    btnCaption.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
        If KeyAscii = vbKeySpace Then Me.Value = Not Me.Value
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As Integer
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As Integer)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=btnCaption,btnCaption,-1,ShadowColor
Public Property Get ShadowColor() As OLE_COLOR
Attribute ShadowColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ShadowColor = btnCaption.ShadowColor
End Property

Public Property Let ShadowColor(ByVal New_ShadowColor As OLE_COLOR)
    btnCaption.ShadowColor() = New_ShadowColor
    PropertyChanged "ShadowColor"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = imgTrue.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    For Each Control In UserControl
        Control.Enabled = New_Enabled
    Next
    PropertyChanged "Enabled"
End Property

Public Property Get TCI() As Boolean
Attribute TCI.VB_Description = "Determines if clicking on image toggles change or not."
    TCI = m_TCI
End Property

Public Property Let TCI(ByVal New_TCI As Boolean)
    m_TCI = New_TCI
    PropertyChanged "TCI"
End Property

Public Property Get TCT() As Boolean
Attribute TCT.VB_Description = "Determines if clicking on text toggles change or not."
    TCT = m_TCT
End Property

Public Property Let TCT(ByVal New_TCT As Boolean)
    m_TCT = New_TCT
    PropertyChanged "TCT"
End Property

Public Property Get Value() As Boolean
    Value = imgTrue.Visible
End Property

Public Property Let Value(ByVal New_Value As Boolean)
 If CH Then Exit Property
    imgTrue.Visible = New_Value
    imgFalse.Visible = Not New_Value
    PropertyChanged "Value"
        RaiseEvent Change
On Error Resume Next
    If UserControl.Extender.Index <> "" And Value Then
        For Each optBlack In UserControl.Extender.Container
            If optBlack.Name = UserControl.Extender.Name Then
                If optBlack.Index <> UserControl.Extender.Index Then optBlack.Value = False
            End If
        Next
            CH = True: Value = True: CH = False
    End If
    imgTrue.Visible = Value
    imgFalse.Visible = Not Value
End Property

Public Property Get RightAligned() As Boolean
    RightAligned = prpRA
End Property

Public Property Let RightAligned(ByVal New_RA As Boolean)
    If New_RA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
            prpRA = New_RA
        PropertyChanged "RightAligned"
End Property

Public Property Get FocusColor() As OLE_COLOR
    FocusColor = btnCaption.FocusColor
End Property

Public Property Let FocusColor(ByVal New_FocusColor As OLE_COLOR)
    btnCaption.FocusColor() = New_FocusColor
    PropertyChanged "FocusColor"
End Property

Public Sub ReCall()
On Error Resume Next
    If UserControl.Extender.Index <> "" And Value Then
        For Each optBlack In UserControl.Extender.Container
            If optBlack.Name = UserControl.Extender.Name And optBlack.Index <> UserControl.Extender.Index Then optBlack(i).Value = False
        Next
            CH = True: Value = True: CH = False
    End If
    imgTrue.Visible = Value
    imgFalse.Visible = Not Value
    If prpRA Then
        imgTrue.Left = UserControl.Width - 300
        imgFalse.Left = UserControl.Width - 300
        btnCaption.Left = UserControl.Width - (405 + btnCaption.Width)
    Else
        imgTrue.Left = 60
        imgFalse.Left = 60
        btnCaption.Left = 405
    End If
        imgTrue.Top = (UserControl.Height - imgTrue.Height) / 2
        imgFalse.Top = imgTrue.Top
        btnCaption.Top = (UserControl.Height - btnCaption.Height) / 2
End Sub
